using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using System.IO;
using System.Text;
using System.Net;

namespace HTTPSender
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
      protected System.Web.UI.WebControls.Label Label1;
      protected System.Web.UI.WebControls.Label Label2;
      protected System.Web.UI.WebControls.DropDownList TypeList;
      protected System.Web.UI.WebControls.Label Label3;
      protected System.Web.UI.WebControls.TextBox Location;
      protected System.Web.UI.WebControls.Label Label4;
      protected System.Web.UI.WebControls.TextBox Notes;
      protected System.Web.UI.WebControls.Label  Status;
      protected System.Web.UI.WebControls.Button Submit;
   
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
		}
      private void Submit_Click(object sender, System.EventArgs e) 
      {
         // TODO: requestLocation must be changed to reflect your environment.
         // The format of the location is as follows:
         //
         // http://<servername>/<virtual dir>/BTSHTTPReceive.dll
         //
         // where <servername> = the machine name of the web server you will be posting to
         //       <virtual dir> = the virtual directory where this file resides

         // indicates the location where the HTTP request is to be sent
         string requestLocation = "http://atropos/HTTPSender/BTSHTTPReceive.dll";
         Status.Text = "";
         // create an XML object
         XmlDocument xmlDocument = new XmlDocument();
         xmlDocument.PreserveWhitespace = true;

         // create the root node named Activity
         XmlNode tempXmlNode = xmlDocument.CreateNode(XmlNodeType.Element, "Activity", "http://que.activity");
         xmlDocument.AppendChild(tempXmlNode);

         // create the type attribute
         tempXmlNode = xmlDocument.CreateNode(XmlNodeType.Attribute, "type", "");
         tempXmlNode.Value = TypeList.SelectedItem.Text;
         //xmlDocument.DocumentElement.AppendChild(tempXmlNode);
         xmlDocument.DocumentElement.Attributes.Append((XmlAttribute)tempXmlNode);
         
         // create the Location element
         tempXmlNode = xmlDocument.CreateNode(XmlNodeType.Element, "Location", "");
         tempXmlNode.InnerText = Location.Text;
         xmlDocument.DocumentElement.AppendChild(tempXmlNode);

         // create the Timestamp element
         tempXmlNode = xmlDocument.CreateNode(XmlNodeType.Element, "Timestamp", "");
         DateTime now = DateTime.Now;
         tempXmlNode.InnerText = now.ToString("s");
         xmlDocument.DocumentElement.AppendChild(tempXmlNode);

         // create the Notes element
         tempXmlNode = xmlDocument.CreateNode(XmlNodeType.Element, "Notes", "");
         tempXmlNode.InnerText = Notes.Text;
         xmlDocument.DocumentElement.AppendChild(tempXmlNode);

         try 
         {

            // create a web request and set the method of the request to POST
            HttpWebRequest request = (HttpWebRequest) HttpWebRequest.Create(requestLocation);
            request.Method = "POST";

            // encode the data and store the byte representation in an array
            ASCIIEncoding encoding = new ASCIIEncoding();
            byte[] requestData = encoding.GetBytes(xmlDocument.OuterXml);

            // set the content type of the data being posted.
            request.ContentType="application/x-www-form-urlencoded";

            // set the content length of the string being posted
            request.ContentLength = xmlDocument.OuterXml.Length;

            Status.Text += "Submitting activity message";

            Stream requestStream = request.GetRequestStream();
            requestStream.Write(requestData,0,requestData.Length);

            // flush out the data to the underlying stream and close it
            requestStream.Flush();
            requestStream.Close();

            // retrieve the response from the web server
            HttpWebResponse response = (HttpWebResponse) request.GetResponse();
            StreamReader responseData = new StreamReader(response.GetResponseStream());
            Status.Text = System.Web.HttpUtility.HtmlEncode(responseData.ReadToEnd()) + "<br>";
         } 
         catch (WebException wex) 
         {
            Status.Text = "Unable to complete web request. Web Exception error: " + wex.Message;
         }   
      }
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
         this.Submit.Click += new System.EventHandler(this.Submit_Click);
         this.Load += new System.EventHandler(this.Page_Load);

      }
		#endregion
	}
}
